/*  SYSTEMTICK.C   SwissBetty: Unit fr die Zeitverwaltung im LPC2220 */

#include "LPC22xx.h"
#include "StdTypes.h"
#include "setup.h"
#include "events.h"
#include "systemtick.h"
#include "systemtick_ISR.h"
#include "Tasten.h"

/*
Als innere Uhr wird der Timer0 benutzt, der pro Millisekunde um 1 weiterzhlt.
Sein Zhlerstand ist also gleichbedeutend mit der Uhrzeit in Millisekunden.
*/

#if defined (GCC)
void __attribute__ ((interrupt("IRQ")))  Timer0Service (void)
#else
#pragma arm
void __irq Timer0Service (void)
#endif
{ T0IR  = 0xFF;                            /* IRQ im Timer lschen        */
  T0MR0 = T0TC + 10; 

  if (T0TC >= 86400000) { Uhr = T0TC = 0; }
  Tasten_Bonze();
  ++Ticks;
  if ((Ticks==20)||
      (Ticks==40)||
      (Ticks==60)||
      (Ticks==80))  Add_Event(id_200_milli);
  if (Ticks >= 100)
  { Ticks = 0;
    Add_Event(idSekundeUm);
  } 
  VICVectAddr = 0;                         /* clear Interrupt             */
}

#if !defined (GCC)
#pragma thumb
#endif
